	<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<title>Products</title>
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css">
	<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css">
	<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/css/bootstrap-datepicker.standalone.min.css">
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
	<style>
		.form-group.required > label:first-child:after {
		  content:"*";
		  color:red;
		}
	</style>
</head>
<body>
	<div class="container mt-2">
		<div class="card">
			<div class="card-header bg-primary text-white">Product List</div>
			<div class="card-body">
				<table id="table_id"
					class="table table-striped table-bordered dataTable">
					<thead>
						<tr>
							<th>Name</th>
							<th>Description</th>
							<th>Unit Price</th>
							<th>Quantity</th>
							<th>Production Date</th>
							<th>Expiry Date</th>
							<th>Edit</th>
							<th>Delete</th>
						</tr>
					</thead>
				</table>
			</div>
		</div>
	</div>
	<div class="container mt-5">
		<div class="card">
			<div class="card-header bg-primary text-white">Product Form</div>
			<div class="card-body">
				<form id="productForm" class="needs-validation" novalidate>
					<div class="form-group required">
						<label for="name">Name</label> 
						<input type="text" class="form-control"
							id="name" placeholder="Enter name" autocomplete="off" required />
						<div class="invalid-feedback">Please enter a name</div>
					</div>
					<div class="form-group">
						<label for="description">Description</label>
						<textarea class="form-control" rows="5" id="description"
							placeholder="Enter description" maxlength="250"></textarea>
						<small id="descriptionHelp" class="form-text text-muted">Maximum allowed length is 250 characters</small>
					</div>
					<div class="form-group required">
						<label for="price">Price</label> 
						<input id="price" type='number' min="0.01"
							step="0.01" class="form-control" placeholder="Enter price"
							autocomplete="off" required />
						<div class="invalid-feedback">Please enter price</div>
					</div>
					<div class="form-group required">
						<label for="quantity">Quantity</label> <input id="quantity" type='number' min="1"
							class="form-control" placeholder="Enter quanitiy"
							autocomplete="off" required />
						<div class="invalid-feedback">Please enter quantity</div>
					</div>
					<div class="row">
						<div class="col">
							<div class="form-group required">
								<label for="prodDate">Production Date</label>
								<div class="input-group date">
									<div class="input-group-prepend">
										<span class="input-group-text" id="basic-addon1"><i
											class="fa fa-calendar"></i></span>
									</div>
									<input id="prodDate" data-provide="datepicker"
										data-date-format="yyyy-mm-dd" class="form-control"
										data-date-clear-btn="true" data-date-today-highlight="true" data-date-end-date="0d"
										placeholder="yyyy-mm-dd"
										autocomplete="off" required />
									<div class="invalid-feedback">Please enter production date</div>
								</div>
							</div>
						</div>
						<div class="col">
							<div class="form-group required">
								<label for="expiryDate">Expiry Date</label>
								<div class="input-group date">
									<div class="input-group-prepend">
										<span class="input-group-text" id="basic-addon1"><i
											class="fa fa-calendar"></i></span>
									</div>
									<input id="expiryDate" data-provide="datepicker"
										data-date-format="yyyy-mm-dd" class="form-control"
										data-date-start-date="0d" placeholder="yyyy-mm-dd" data-date-clear-btn="true" data-date-today-highlight="true"
										autocomplete="off" required />
									<div class="invalid-feedback">Please enter expiry date</div>
								</div>
							</div>
						</div>
					</div>
					<div class="float-right">
						<button id="resetBtn" type="button" class="btn btn-secondary">Reset</button>
						<button id="submitBtns" type="submit" class="btn btn-primary ">Submit</button>
					</div>
				</form>
			</div>
		</div>
	</div>

	<!-- Modal -->
	<div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
	  <div class="modal-dialog" role="document">
	    <div class="modal-content">
	      <div class="modal-header">
	        <h5 class="modal-title" id="exampleModalLabel">Confirmation</h5>
	        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
	          <span aria-hidden="true">&times;</span>
	        </button>
	      </div>
	      <div class="modal-body">
	        ...
	      </div>
	      <div class="modal-footer">
	        <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
	        <button id="deleteBtn" type="button" class="btn btn-primary" data-dismiss="modal">Delete</button>
	      </div>
	    </div>
	  </div>
	</div>

	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/js/bootstrap-datepicker.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js"></script>
	<script src="https://momentjs.com/downloads/moment.js"></script>s
	
	<script type="text/javascript">
		var selectedProduct;
		var editMode;
		var uri = '/product';

		$(document).ready( function () {
			
			$("body").tooltip({ selector: '[data-toggle=tooltip]' });
			
			$('#table_id').DataTable({
				responsive: true,
				ajax: {
					url: uri+'/api/product/',
					dataSrc: ''
				},
				columns: [
					{ data : "name" },
					{ data : "description" },
					{ data : "price" },
					{ data : "quantity" },
					{ data : "productionDate" },
					{ data : "expiryDate" },
					{
						orderable: false, 
						render : function(data, type, row) {
							return "<a href='javascript:void(0)' onClick='editProduct("+ JSON.stringify(row) +");'>Edit</a>";
						}
					},
					{
						orderable: false, 
						render : function(data, type, row) {
							return "<a href='javascript:void(0)' data-product-name='"+ row.name +"' data-product-id='"+ row.id +"' data-toggle='modal' data-target='#exampleModal'>Delete</a>";
						}
					}
				]
			});
			
		});

		$('#resetBtn').click(function() {
			resetForm();
		});
		
		function processSuccess(result) {
			console.log('request completed successfull');
			reloadGrid();
		}
		
		function submitProductForm() {
			var name = $('#name').val();
			var description = $('#description').val();
			var price = $('#price').val();
			var quantity = $('#quantity').val();
			var productionDate = $('#prodDate').val();
			var expiryDate = $('#expiryDate').val();
			
			if (editMode) {
				
				$.ajax({
					type: 'PUT',
					contentType: 'application/json; charset=utf-8',
					url: uri+'/api/product/'+selectedProduct.id,
					data: JSON.stringify( { name : name , description : description , price : price , productionDate : productionDate , expiryDate : expiryDate , quantity : quantity } ),
					success: function() {
						console.log('request completed successfull');
						selectedProduct = null;
						editMode = false;
						reloadGrid();
					},
					error: processError
				});
				
			} else {

				$.ajax({
					type: 'POST',
					contentType: 'application/json; charset=utf-8',
					url: uri+'/api/product/',
					data: JSON.stringify( { name : name , description : description , price : price , productionDate : productionDate , expiryDate : expiryDate , quantity : quantity } ),
					success: function() {
						console.log('request completed successfull');
						reloadGrid();
					},
					error: processError
				});

			}
			
		}

		function processError(result) {
			$('#productForm').removeClass('was-validated');
			console.log('request completed unsuccessfull');
			console.log(result);
			
			var errorCode = result.status;
			var errorMsg = 'Unable to process your request';
			
			if (result.responseJSON)
				errorMsg = result.responseJSON.message

			alert('Error['+errorCode+']: '+errorMsg);
		}
		
		function reloadGrid() {
			var table = $('#table_id').DataTable();

			setTimeout( function () {
			    table.ajax.reload( function() {
			    	resetForm();
				}, false ); 
			}, 100 );
		}

		function resetForm() {
			$('#productForm').removeClass('was-validated');
			$('#name').val('');
			$('#description').val('');
			$('#price').val('');
			$('#quantity').val('');
			$('#prodDate').val('');
			$('#expiryDate').val('');
			selectedProduct = null;
			editMode = false;
		}
		
		function editProduct(product) {
			$('#name').focus();
			selectedProduct = product;
			editMode = true;
			$('#name').val(product.name);
			$('#description').val(product.description);
			$('#price').val(product.price);
			$('#quantity').val(product.quantity);
			$('#prodDate').val(product.productionDate);
			$('#expiryDate').val(product.expiryDate);
		}

		function deleteProduct(productId) {

			$.ajax({
				type: 'DELETE',
				contentType: 'application/json; charset=utf-8',
				url: uri+'/api/product/'+productId
			});

			reloadGrid();
		}

		$('#exampleModal').on('show.bs.modal', function (event) {
		  var button = $(event.relatedTarget) // Button that triggered the modal
		  var productName = button[0].dataset.productName
		  var productId =  button[0].dataset.productId
		  // If necessary, you could initiate an AJAX request here (and then do the updating in a callback).
		  // Update the modal's content. We'll use jQuery here, but you could use a data binding library or other methods instead.
		  var modal = $(this)
		  //modal.find('.confirmation-msg').text('Are you sure you want to delete ' + productName)
		  modal.find('.modal-body').html('Are you sure you want to delete the product \'' + productName + '\'?')
		  $('#deleteBtn').attr('onClick','deleteProduct('+ productId +')');
		});
		
	</script>
	
	<script>
		// Example starter JavaScript for disabling form submissions if there are invalid fields
		(function() {
		  'use strict';
		  window.addEventListener('load', function() {
			  
			  var form = $('#productForm')[0];
				
				form.addEventListener('submit', function(event) {
			          event.preventDefault();
			          event.stopPropagation();
			        if (form.checkValidity() === true) {
			        	submitProductForm();
			        } 
			        form.classList.add('was-validated');
			      }, false);
				
	
		  }, false);
		})();
	</script>
</body>
</html>